/*
    Copyright 1982, 1983, 1984
    Alcyon Corporation
    8716 Production Ave.
    San Diego, Ca.  92121

    @(#)putexpr.c	2.5 12/5/84
*/

#ifdef  DEBUG
#include "parser.h"
#include <ctype.h>

char invalid[] = "INVALID";

#define OP_INVALID(op) (op <= 0 || op > 80)
char *opname[] = {
    invalid,                        /*0*/
    "+",                            /*1*/
    "-",                            /*2*/
    "*",                            /*3*/
    "/",                            /*4*/
    "%",                            /*5*/
    ">>",                           /*6*/
    "<<",                           /*7*/
    "&",                            /*8*/
    "|",                            /*9*/
    "^",                            /*10*/
    "!",                            /*11*/
    "U-",                           /*12*/
    "~",                            /*13*/
    "--p",                          /*14*/
    "++p",                          /*15*/
    "p--",                          /*16*/
    "p++",                          /*17*/
    "=",                            /*18*/
    "+=",                           /*19*/
    "-=",                           /*20*/
    "*=",                           /*21*/
    "/=",                           /*22*/
    "%=",                           /*23*/
    ">>=",                          /*24*/
    "<<=",                          /*25*/
    "&=",                           /*26*/
    "|=",                           /*27*/
    "^=",                           /*28*/
    "jsr",                          /*29*/
    "==",                           /*30*/
    "!=",                           /*31*/
    ">",                            /*32*/
    ">=",                           /*33*/
    "<",                            /*34*/
    "<=",                           /*35*/
    "int->long",                    /*36*/
    "long->int",                    /*37*/
    "btst",                         /*38*/
    "load",                         /*39*/
    "long*",                        /*40*/
    "long/",                        /*41*/
    "long%",                        /*42*/
    "long*=",                       /*43*/
    "long/=",                       /*44*/
    "long%=",                       /*45*/
    "=addr",                        /*46*/
    "=not",                         /*47*/
    "=neg",                         /*48*/
    "docast",                       /*49*/
    "ltof",                         /*50*/
    "ftol",                         /*51*/
    "itof",                         /*52*/
    "ftoi",                         /*53*/
    "tochar",                       /*54*/
    "int->ul",                      /*55*/
    "touchar",                      /*56*/
    "ftod",                         /*57*/
    "dtof",                         /*58*/
    "st=",                          /*59*/
    "U&",                           /*60*/
    "U*",                           /*61*/
    "&&",                           /*62*/
    "||",                           /*63*/
    "?",                            /*64*/
    ":",                            /*65*/
    ",",                            /*66*/
    "cint",                         /*67*/
    "clong",                        /*68*/
    "symbol",                       /*69*/
    "++a",                          /*70*/
    "a--",                          /*71*/
    "call",                         /*72*/
    "call()",                       /*73*/
    "bitfield",                     /*74*/
    "if",                           /*75*/
    "init",                         /*76*/
    "loadR0",                       /*77*/
    "divlong",                      /*78*/
    "cdouble",                      /*79*/
    "lrcomma",                      /*80*/
    "cast",                         /*81*/
};

char *types[] = {
    "typeless",                     /*000=TYPELESS*/
    "char",                         /*001=CHAR*/
    "enum",                         /*002=ENUM*/
    "int",                          /*003=INT/SHORT*/
    "long",                         /*004=LONG*/
    "uchar",                        /*005=UCHAR*/
    "void",                         /*006=VOID*/
    "uint",                         /*007=UINT/USHORT*/
    "ulong",                        /*010=ULONG*/
    "float",                        /*011=FLOAT*/
    "double",                       /*012=DOUBLE*/
    "struct",                       /*013=STRUCT*/
    "frstruct",                     /*014=FRSTRUCT*/
    "label",                        /*015=LLABEL*/
    invalid,                        /*016=undefined*/
    invalid,                        /*017=undefined*/
};

char *suvals[] = {
    "zero",
    "one",
    "quick",
    "small",
    "constant",
    "Areg",
    "Dreg",
    "addressable",
    "loadable",
    "easy",
    "hard",
    "veryhard",
};

short level;

putexpr(name,tp)
char *name;
struct tnode *tp;
{
    printf("%s\n",name);
    if (tp != 0)
        putsexpr(tp);
}

putsexpr(tp)
struct tnode *tp;
{
    register short op;
    char ch;

    level++;
    op = tp->t_op;
    outlevel();
    printf("%s ",opname[op]);
    puttsu(tp);
    switch (op)  {

    case DCLONG:
    case CLONG:
    case CDOUBLE:    /*[vlh] 3.4 */
        printf(" %x.%x\n",((struct lconode *)tp)->t_lvalue.hiword,
                 ((struct lconode *)tp)->t_lvalue.loword);
        if (op==CDOUBLE && hfpflag)
            printf(" %x.%x\n",((struct lconode *)tp)->t_fp2value.hiword,
                     ((struct lconode *)tp)->t_fp2value.loword);
        break;

    case CINT:
        printf(" %d [0x%x]\n",tp->t_value,tp->t_value);
        break;

    case AUTODEC:
    case AUTOINC:
        printf("Autodec or Autoinc");
        break;

    case SYMBOL:
        switch( ((struct symnode *)tp)->t_sc ) {

        case REGISTER:
            printf(" Register");
            break;

        case CINDR:
            printf(" %d\n",((struct symnode *)tp)->t_offset);
            break;

        case CLINDR:
        case CFINDR:    /* [vlh] 3.4 */
            printf(" %x.%x\n",((struct symnode *)tp)->t_offset,tp->t_ssp);
            break;

        case REGOFF:
            printf(" Regoffset");
            break;

        case EXTERNAL:
        case EXTOFF:
            printf(" %s+%d",tp->t_symbol,tp->t_offset);
            if( tp->t_sc == EXTOFF )
                printf("Ext offset");
            break;

        case STATIC:
        case STATOFF:
            printf(" STATIC or STATOFF");
            if( ((struct symnode *)tp)->t_sc == STATOFF )
                printf("STATOFF");
            break;

        case INDEXED:
            printf(" %d indexed",((struct symnode *)tp)->t_offset);
            break;
        }
        putchar('\n');
        break;

    case IFGOTO:
        putsexpr(tp->t_left);
        break;

    default:
        putchar('\n');
        putsexpr(tp->t_left);
        if( BINOP(tp->t_op) )
            putsexpr(tp->t_right);
        break;
    }
    level--;
}

outlevel()
{
    register short i;

    for( i = 0; i < level; i++ )
        printf("     ");
}

puttsu(tp)
struct tnode *tp;
{
    register short i;

    switch( SUPTYPE(tp->t_type) ) {

    case FUNCTION:
        printf("()");
        break;

    case ARRAY:
        printf("[]");
        break;

    case POINTER:
        printf("*");
        break;
    }
    printf("%s ",types[BTYPE(tp->t_type)]);
}


putheir(sp)
struct symbol *sp;
{
    if (sp->s_par)
        printf("    par  [%s]\n",sp->s_par->s_symbol);
    else
        printf("    par  NULL\n");
    if (sp->s_child)
        printf("    chld [%s]\n",sp->s_child->s_symbol);
    else
        printf("    chld NULL\n");
    if (sp->s_sib)
        printf("    sib  [%s]\n",sp->s_sib->s_symbol);
    else
        printf("    sib  NULL\n");
}
#endif
